<template>
    <div>
        <Base activeIndex="2">


        </Base>
        <div class="container">
            <el-row class="header">
                <el-col>
                    发布德育分活动
                </el-col>
            </el-row>
            <el-row>
                <el-card class="box-card">
                    <el-row class="main">
                        <el-col :span="10">
                            <el-upload class="avatar-uploader" action="https://jsonplaceholder.typicode.com/posts/"
                                :show-file-list="false" :on-success="handleAvatarSuccess">
                                <img v-if="imageUrl" :src="imageUrl" class="avatar" />
                                <el-icon v-else class="avatar-uploader-icon">
                                    <Plus />
                                </el-icon>
                            </el-upload>
                        </el-col>
                        <el-col :span="10" :offset="2" class="form">
                            <el-form ref="ruleFormRef" :model="ruleForm" :rules="rules" label-width="80px"
                                class="demo-ruleForm" :size="formSize">
                                <el-form-item label="活动名称" prop="name">
                                    <el-input v-model="ruleForm.name" />
                                </el-form-item>

                                <el-form-item label="起始时间" required>
                                    <el-col :span="11">
                                        <el-form-item prop="date1">
                                            <el-date-picker v-model="ruleForm.date1" 
                                                label="Pick a date"
                                                placeholder="Pick a date" 
                                                format="YYYY/MM/DD"
                                                style="width: 100%" />
                                        </el-form-item>
                                    </el-col>
                                    <el-col class="text-center" :span="2">
                                        <span class="text-gray-500">-</span>
                                    </el-col>
                                    <el-col :span="11">
                                        <el-form-item prop="date2">
                                            <el-time-picker v-model="ruleForm.time1" label="Pick a time"
                                                placeholder="Pick a time" style="width: 100%" />
                                        </el-form-item>
                                    </el-col>
                                </el-form-item>
                                <el-form-item label="结束时间" required>
                                    <el-col :span="11">
                                        <el-form-item prop="date2">
                                            <el-date-picker v-model="ruleForm.date2" 
                                                label="Pick a date"
                                                placeholder="Pick a date" 
                                                format="YYYY/MM/DD"
                                                style="width: 100%" />
                                        </el-form-item>
                                    </el-col>
                                    <el-col class="text-center" :span="2">
                                        <span class="text-gray-500">-</span>
                                    </el-col>
                                    <el-col :span="11">
                                        <el-form-item prop="date2">
                                            <el-time-picker v-model="ruleForm.time2" label="Pick a time"
                                                placeholder="Pick a time" style="width: 100%" />
                                        </el-form-item>
                                    </el-col>
                                </el-form-item>
                                <el-form-item label="负责学院" prop="region">
                                    <el-input v-model="ruleForm.academy">
                                    </el-input>
                                </el-form-item>
                                <el-form-item label="活动分数" prop="name">
                                    <el-input v-model="ruleForm.score" />
                                </el-form-item>
                                <el-form-item label="活动人数" prop="nums">
                                    <el-input v-model="ruleForm.nums" />
                                </el-form-item>
                                <el-form-item label="活动描述" prop="desc">
                                    <el-input v-model="ruleForm.desc" type="textarea" />
                                </el-form-item>
                                <el-form-item>
                                    <el-button type="primary" @click="submitForm(ruleFormRef)" class="submitBtn">
                                        发布活动
                                    </el-button>
                                </el-form-item>
                            </el-form>
                        </el-col>
                    </el-row>
                </el-card>
            </el-row>
        </div>
    </div>
</template>

<script lang="ts">
import global from "./Common.vue"
import Base from "./Base.vue";
export default {
    name: "ActivityIssue",
    data() {
        return {
            ip: global.ip,
        }
    },
    components: {
        Base
    }
}
</script>

<script lang="ts" setup>
import { reactive, ref } from 'vue'
import axios from "axios";

import type { FormInstance, FormRules } from 'element-plus'
import { ElMessage } from 'element-plus'
import { Plus } from '@element-plus/icons-vue'

import type { UploadProps } from 'element-plus'

const formSize = ref('default')
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
    name: '',
    score: '',
    date1: '',
    time1: '',
    date2: '',
    time2: '',
    academy: '',
    desc: '',
    nums: ''
})

const imageUrl = ref('');
const handleAvatarSuccess: UploadProps['onSuccess'] = (
    response,
    uploadFile
) => {
    imageUrl.value = URL.createObjectURL(uploadFile.raw!)
};



const rules = reactive<FormRules>({
    name: [
        { required: true, message: '请输入活动名称', trigger: 'blur' },
    ],
    score: [
        { required: true }
    ],
    academy: [
        {
            required: true,
        },
    ],
    date1: [
        {
            type: 'date',
            required: true,
        },
    ],
    date2: [
        {
            type: 'date',
            required: true,
        },
    ],
    desc: [
        { required: true, message: '请输入活动详情', trigger: 'blur' },
    ],
    nums: [{
        required: true
    }]
})

const submitForm = async (formEl: FormInstance | undefined) => {
    if (!formEl) return
    let token = localStorage.getItem("token");
    await formEl.validate((valid, fields) => {
        if (valid) {
            let datestr1 = String(ruleForm.date1)
            let datestr2 = String(ruleForm.date2)
            let datestrs1 = datestr1.split(" ")
            let datestrs2 = datestr2.split(" ")
            let date1str = datestrs1[3]+'-06-'+datestrs1[2] + ' '
            let date2str = datestrs2[3]+'-06-'+datestrs2[2] + ' '

            let timestr1 = String(ruleForm.time1)
            let timestr2 = String(ruleForm.time2)
            let timestrs1 = timestr1.split(" ")
            let timestrs2 = timestr2.split(" ")
            let time1str = timestrs1[4]
            let time2str = timestrs2[4]

            axios({
                method: "POST",
                url: "http://" + global.ip + "/api/manage/createAct",
                data: {
                    topic: ruleForm.name,
                    content: ruleForm.desc,
                    stime: date1str+ time1str,
                    etime: date2str+time2str,
                    academy: ruleForm.academy,
                    score: ruleForm.score,
                    nums: ruleForm.nums
                },
                headers: { Authorization: `Bearer: ${token}` }
            }).then((res) => {
                console.log(res);
                if (res.data.code === '00'){
                    alert("success submit!");
                    window.location.replace("http://" + global.ip_front + "/activities_detailed");
                }          
                else
                    alert(res)
            });
        } else {
            console.log('error submit!', fields)
        }
    })
}
</script>

<style scoped>
a {
    text-decoration: none;
    color: white;
}

.container {
    position: absolute;
    width: 100%;
    height: 100%;
    background-color: rgb(238, 241, 246);
}

.box-card {
    position: relative;
    width: 75%;
    height: 80%;
    top: 70px;
    left: 200px;
    padding: 50px;
}

.main {
    height: 700px;
    margin: 0px;
}

img {
    width: 700px;
    height: 600px;
}

.form {
    position: relative;
    top: 100px;
}

.header {
    position: relative;
    font-size: 50px;
    top: 30px;
}

/deep/ .el-form-item {
    margin-bottom: 30px;
}

/deep/ .submitBtn {
    position: relative;
    width: 130px;
    height: 50px;
    font-size: 20px;
    left: 120px;
}

.avatar-uploader {
    position: relative;
    width: 100%;
    height: 450px;
    top: 100px;
    display: block;
}
</style>

<style scoped>
/deep/ .el-upload {
    width: 100%;
    height: 100%;
    border: 1px dashed var(--el-border-color);
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

/deep/ .el-upload:hover {
    border-color: black;
}

.avatar {
    width: 100%;
}

.avatar-uploader-icon {
    width: 100%;
}

.el-icon.avatar-uploader-icon {
    font-size: 48px;
    color: #8c939d;
    width: 100%;
    height: 100%;
    text-align: center;
}
</style>